scr1 = require("rendering")
scr2 = require("sound_manager")

g_scale = 6
tile_size = 11 * g_scale
gravity = 30


love.keyboard.setKeyRepeat(true)
entity_list = {}

function new_player(id,pos_x,pos_y,width,height,dta_img)
 img = love.graphics.newImage(dta_img)
 img:setFilter("nearest","nearest")

 entity = {entity_id = id,
                  x = pos_x * tile_size,
                  y = pos_y * tile_size,
                  w = width,
                  h = height,
                  velocity_x = 0,
                  velocity_y = 0,
                  jump_height = 5,
                  jump_hold = 0,
                  jump_hold_max = 10,
                  clock_1 = 0,
                  clock_2 = 0,
}

add_sound(id.. 1, "data/audio/Jump.wav", "static", false, 1)
 table.insert(entity_list, entity)
end



function entity_tick(dt)
 for i,v in pairs (entity_list) do
  local block = entity_list[i]
  if block.entity_id ~= nil then
    block.clock_1 = block.clock_1 + 1
    block.clock_2 = block.clock_2 + 1
    if block.velocity_y ~= 0  then  
   block.y = block.y  - (block.velocity_y +  block.jump_hold)
   block.velocity_y  = block.velocity_y  - gravity * dt
  end

  if block.y > 200 then --floor collision
  block.y = 200
  block.velocity_y = 0
  end
  end
end
end



function player_key(id,key,dt)
for i,v in pairs (entity_list) do
  local block = entity_list[i]
if block.entity_id == id then

if love.keyboard.isDown(key) then --activate jumping
if block.velocity_y == 0 then
 block.velocity_y = block.jump_height
 block.jump_hold = 0
 sound_setting(id.. 1, false, "Play")
end
if block.jump_hold < block.jump_hold_max then 
 block.jump_hold = block.jump_hold + .5
end
end

end
end
end


function player_state(id,rotatable,state) --player textures
  for i,v in pairs (entity_list) do
  local block = entity_list[i]
  if block.entity_id == id then

  frame_x, frame_y = 0, 0
  if state == "Idle" then
      frame_x ,frame_y = 0, 0
  elseif state == "Idle2" then
      frame_x ,frame_y = 13, 0
  elseif state == "Crouch" then
      frame_x ,frame_y = 26, 0
  elseif state == "Crouch2" then
      frame_x ,frame_y = 39, 0
  elseif state == "Walk1" then
      frame_x ,frame_y = 0, 19
  elseif state == "Walk2" then
      frame_x ,frame_y = 13, 19
  elseif state == "Jump" then
      frame_x ,frame_y = 26, 19
  end
  frame = love.graphics.newQuad(frame_x, frame_y, block.w, block.h, img:getWidth(), img:getHeight())
  love.graphics.draw(img, frame, block.x, block.y, 0, -g_scale,g_scale,0,0)
  end
  end
end



function love.load()
add_sound("BGM1", "data/audio/overworldO.ogg", "static", true, 1)
sound_setting("BGM1",false,"Play")
new_player("Player",2,5,13,19,"data/graphics/Sprite1.png")
new_player("Player2",3,5,13,19,"data/graphics/Sprite1.png")
end

function love.update(dt)
entity_tick(dt)
player_key("Player","up")
player_key("Player2","down")

if love.keyboard.isDown("w") then
change_map(lvl2)
end
end

function love.draw()
render_map()
player_state("Player",true,"Idle")
player_state("Player2",true,"Idle")
end
